'****************************************************************
' QI-OSD-Modul umbau fr OE7PKI                                 *
'                                                               *
' -- Version v3a PKI 11.01.2015                                 *
'  - Tasten und Trigger und CW eingefgt                        *
'                                                               *
'****************************************************************
'****************************************************************
' MCS-Bootloader verwendet um leichter die Soft in M8 zu laden  *
'****************************************************************
'DEBUG ON
'****************************************************************
'  Prozessor relevante Einstellungen                            *
'****************************************************************
$regfile = "M168def.dat"                                     ' ! Osccal setzen !
$crystal = 8000000
$baud = 9600
$hwstack = 100                                               ' default use 50 for the hardware stack
$swstack = 100                                               ' default use 25 for the SW stack
$framesize = 100                                             ' default use 60 for the frame

'****************************************************************
'   Ein und Ausgnge                                            *
'   IC-Leitungen                                               *
'****************************************************************
 '   OSD-Leitungen
Config Pinb.1 = Input
Config Pinb.2 = Output
Config Pinb.3 = Output
Config Pinb.4 = Output
Config PinB.5 = Output
Config PinC.2 = Output
Config Pind.2 = Output
Config Pind.6 = Output
Portb.1 = 1                                                ' Pullups einschalten
PortB.5 = 1
Osd_sync Alias Pinb.1                                      ' Video detekt
Osd_en   Alias Portb.2                                       ' OSD Enable
Osd_clk Alias Portb.3                                      ' OSD Clock
Osd_dat Alias Portb.4                                      ' OSD Data
'Tasten
Config PINC.4 = Input                                      ' SDA Auf
Config PINC.5 = Input                                      ' SCL Ab
Config PIND.3 = Input                                      ' Trig
Config PIND.4 = Input                                      ' O/I Menue
PortC.4 = 1                                                ' Pullups einschalten
PortC.5 = 1                                                ' Pullups einschalten
PortD.3 = 1                                                ' Pullups einschalten
PortD.4 = 1                                                ' Pullups einschalten
T_Auf alias PinC.4
T_ab  alias PinC.5
T_Menue alias PinD.4
Trig alias PinD.3

CW_Out alias PortD.2
PTT alias PORTC.2
'*************************************************************************
'* Timer -Einstellungen                                                  *
'*************************************************************************
Config Timer2 = Timer , Prescale = 1024                     'konfiguriere Timer2 fr LCD-Led
Enable Timer2
'****************************************************************
'   Variable                                                    *
'****************************************************************
Dim I As Byte
Dim N As Byte
Dim J As Word
Dim K As Byte

Dim Bytes As Word
Dim Byte1 As Byte
Dim Byte2 As Byte
Dim Lin As Byte                                             ' Zeilennummer
Dim Col As Byte                                             ' Spaltennummer
Dim Colalt As Byte
Dim Tlin As Byte                                            ' Zeilennummer
Dim Tcol As Byte                                            ' Spaltennummer
Dim Text As String * 24
Dim Etext As String * 220
Dim T As String * 1
Dim Bitbyte As Byte
Dim Temp As Byte
Dim Zeigtitel As Byte
Dim Zeigtitel_T As Byte
Dim Eingabe As String * 1
Dim Osd_on_off_alt As Bit
Dim Osd_n As Byte
Dim Laden As Bit
Dim Ezaehler As Byte

dim Logo_ein_t as byte
Dim Logo_ein_alt as Byte

dim Pos_xy as Byte
dim Logo as string*24
dim min_timer as Word
dim Min_rum as Byte
'****************************************************************
'   Command Strukturen                                          *
'****************************************************************
Dim Comx(8) As Word
Dim Com1 As Word At Comx Overlay
Dim Com2 As Word At Comx + 2 Overlay
Dim Com3 As Word At Comx + 4 Overlay
Dim Com4 As Word At Comx + 6 Overlay
Dim Com5 As Word At Comx + 8 Overlay
Dim Com6 As Word At Comx + 10 Overlay
Dim Com7 As Word At Comx + 12 Overlay
Dim Com0 As Word At Comx + 14 Overlay
Dim Comd As Word
'Com6 und Com7  unntig zu  setzen, beim lschen alle Bits 0, damit OK
' Display character data write setup aommand
Attribut Alias Com1.0                                      ' Attribut bit
' Vertical display start position and vertical character size setup command
Vs21 Alias Com2.11                                         ' Zeile 2 Schrift gre 1H 2H 3H 1H
Vs20 Alias Com2.10
Vs11 Alias Com2.9                                          ' Zeile 1 Schrift gre 1H 2H 3H 1H
Vs10 Alias Com2.8
Fs Alias Com2.6                                            ' 0=2fsc 1=4fsc
Vp5 Alias Com2.5                                           ' V-Startposition 2H schrittweite
Vp4 Alias Com2.4
Vp3 Alias Com2.3
Vp2 Alias Com2.2
Vp1 Alias Com2.1
Vp0 Alias Com2.0
' Horizontal display start position and horizontal charactersize setup command
Hs21 Alias Com3.11                                         ' Zeile 2 Schrift gre 1V 2V 3V 1V
Hs20 Alias Com3.10
Hs11 Alias Com3.9                                          ' Zeile 1 Schrift gre 1V 2V 3V 1V
Hs10 Alias Com3.8
Lc Alias Com3.6                                            ' 0=LC-Osc 1=Xtal-Osc as bitclock
Hp5 Alias Com3.5                                           ' V-Startposition 2H schrittweite
Hp4 Alias Com3.4                                           ' H-Startpunkt
Hp3 Alias Com3.3
Hp2 Alias Com3.2
Hp1 Alias Com3.1
Hp0 Alias Com3.0
' Display control setup command
Tstmod Alias Com4.11                                       ' Testmode mu 0 sein
Ramers Alias Com4.10                                       ' 1 = Displayram lschen braucht 500uS
Oscstp Alias Com4.9                                        ' 1=stop  xtal und LC osc  0= laufenlassen
Sysrst Alias Com4.8                                        ' 1=RESET
Blk2 Alias Com4.6                                          ' 0= Schriftflche an 1=aus
Blk1 Alias Com4.5                                          ' 00 =  kein Blanking 01=Zeichengre
Blk0 Alias Com4.4                                          ' 10 = Rahmen um Zeichen  11=kompl  Zeichen
Bk1 Alias Com4.3                                           ' 0 = 0,5s  1= 1s   blinken
Bk0 Alias Com4.2                                           ' 0 aus  1=ein Blinken
Rv Alias Com4.1                                            ' Revers  0=aus  1=ein
Dspon Alias Com4.0                                         ' Zeichen  0=aus 1=ein
'Display control setup command
Np1 Alias Com5.11                                          ' 00=NTSC 01=Pal-M
Np0 Alias Com5.10                                          ' 10=Pal 11=Pal-N
Non Alias Com5.9                                           ' 0=interlaced 1=noninterlaced
Ints Alias Com5.8                                          ' 0=ext 1=int  Sync
Bcl Alias Com5.4                                           ' 0=HG-Farbe  1=Grau nur wenn Ints=1
Cb Alias Com5.3                                            ' 0=Farbburst 1=kein Farbburst wenn bcl = 1
Ph2 Alias Com5.2                                           '  Farbe   0-7
Ph1 Alias Com5.1
Ph0 Alias Com5.0

'****************************************************************
'   Konstanten  fr LC-OSD                                      *
'****************************************************************
Const Min_timeout = 14500                                  ' 255*1024/8MHz=32,64ms  33ms* 1000= 30s
const Kurz = 70
Dim lang as Byte
'****************************************************************
'   Initialisierung                                             *
'****************************************************************
Enable Interrupts
On Timer2 Min_off                                        ' LCD_Led Timer Interrupt Verweis
Min_rum = 0
Lang = 3*kurz
Laden = 0
PTT = 0
Logo_ein_t = Trig
Logo_ein_alt =Logo_ein_t
gosub Eeprom_lesen
Gosub Osd_init
'****************************************************************
'   Hauptprogramm                                               *
'****************************************************************
Main:
   Do
      Logo_ein_t = Trig
      If Logo_ein_t <> Logo_ein_alt Then
         If Trig = 0 Then
            Min_timer = Min_timeout
            PTT = 1
            Gosub Position
            text= Logo
            Gosub Osd_text
            Logo_ein_alt = 0
            waitms 1000
            gosub CW_Logo
            Gosub Clr_Scn
         Else
            Gosub Position
            text= Logo
            Gosub Osd_text
            gosub CW_Logo
            Gosub Clr_Scn
            Logo_ein_alt = 1
            waitms 500
            PTT = 0
         End If
      End If
      If  Min_rum = 1 and Trig = 0 Then
         Min_rum = 0
         PTT = 1
         Gosub Position
         text= Logo
         Gosub Osd_text
         Logo_ein_alt = 0
         waitms 1000
         gosub CW_Logo
         Gosub Clr_Scn
      end if
      If T_ab = 0 Then
         Incr Lin
         If Lin > 12 Then Lin = 1
         Gosub Position
         Pos_xy = 1
      End If

      If T_auf = 0 Then
         Incr Col
         Colalt = Col
         If Col > 24 Then
            Col = 1
            Lin = Lin + 1
            If Lin > 12 Then Lin = 1
         End If
         Gosub Position
         Pos_xy = 1
      End If

      If Pos_xy = 1 Then
         gosub Clr_Scn
         text= Logo
         Gosub Osd_text
         Pos_xy = 0
         Writeeeprom col , 200
         Writeeeprom lin , 201
         waitms 100
      End If

      If T_Menue = 0 Then gosub Call_Edit
   Loop
'*******************************************************************************
' Zeichenauswertung
'*******************************************************************************
Call_edit:
   Gosub Osd_clr
   text = "Call Eingeben"
   Gosub Osd_text
   Col = 1
   Lin = 2
   gosub Position
   Logo = ""
   For I = 1 to 24
      Eingabe = waitkey()
      if asc(eingabe) = 13 Then exit for
      Eingabe = UCASE(Eingabe)
      Logo = Logo + Eingabe
      Col = 1
      Lin = 2
      Text = Logo
      gosub Position
      Gosub Osd_text
   next
   col = 1
   Lin = 3
   text = "OK"
   gosub Position
   Gosub Osd_text
   Writeeeprom Logo,210
   waitms 2000
   Gosub Osd_clr
Return
'****************************************************************
'       OSD Initialisierung                                     *
'****************************************************************
Osd_init:

   Gosub Disp_aus
   Bytes = &B1100_0001_0000_0000                            ' Com 4 Reset
   Gosub Osd_leitung
   Bytes = &B1100_0100_0000_0000                            ' Com 4 Ram lschen !!!
   Gosub Osd_leitung
   Waitus 600
   For I = 2 To 7                                           ' Alle Com s mal abarbeiten
      Bytes = Comx(i)
      Gosub Osd_leitung
   Next
   Gosub Disp_an
Return
Osd_init2:
   Gosub Disp_aus
   Bytes = &B1100_0001_0000_0000                            ' Com 4 Reset
   Gosub Osd_leitung
   Bytes = &B1100_0100_0000_0000                            ' Com 4 Ram lschen !!!
   Gosub Osd_leitung
   Waitus 600
   Gosub Disp_an
Return
'****************************************************************
'   OSD lschen                                                 *
'****************************************************************
Osd_clr:
   Gosub Disp_aus
   Bytes = &B1100_0100_0000_0000                         ' Com 4 Ram lschen !!!
   Gosub Osd_leitung
   Col = 1
   Lin = 1
   Waitms 1
   goto Disp_an
Clr_Scn:
   Gosub Disp_aus
   Bytes = &B1100_0100_0000_0000                         ' Com 4 Ram lschen !!!
   Gosub Osd_leitung
   Waitms 1
'****************************************************************
'       Display An/Ausschalten                                  *
'****************************************************************
Disp_an:
   Dspon = 1
   Bytes = Com4                                          '&B1100_0000_0010_0001                         ' Com4 Display angeschaltet mit schwarzem Rand um Zeichen
   Gosub Osd_leitung
Return

Disp_aus:
   Dspon = 0
   Bytes = Com4                                          ' Com4 Display aus
   Gosub Osd_leitung
Return
'****************************************************************
'   Text im OSD anzeigen                                        *
'****************************************************************
Osd_text:
   Gosub Position
   For Osd_n = 1 To Len(text)
      T = Mid(text , Osd_n , 1)
      'gosub CW_Zeichen
      Byte2 = T
      Gosub Osd_string
   Next
Return
'****************************************************************
'   String im OSD anzeigen                                      *
'****************************************************************
Osd_string:
   Gosub Zeichenwandlung
   Byte1 = High(com1)                                    '&B1001_0001
   Gosub Leitung2
Return
'****************************************************************
'       Position aus Zeile und Spalte                           *
'****************************************************************
Position:
   Tlin = Lin - 1                                        ' 1. Zeile = 0
   Tcol = Col - 1                                        ' 1. Spalte = 0
   Bytes = Makeint(tcol , Tlin)
   Bytes = Bytes Or Com0
'****************************************************************
'       Daten auf die 3 Leitungen                               *
'****************************************************************
Osd_leitung:                                                ' Byte1 und Byte2 aus Bytes
   Byte1 = High(bytes)
   Byte2 = Low(bytes)
Leitung2:
   Osd_en = 0
   Waitus 3
   Shiftout Osd_dat , Osd_clk , Byte1 , 2                ' Mode 2 (LSB out first, clock falling edge)
   Waitus 3                                              '
   Shiftout Osd_dat , Osd_clk , Byte2 , 2
   Waitus 3
   Osd_en = 1
Return
' Wandlertabelle
'128 = Leer
'135 = ?
'0 -9 0 -9
'-:/.,' 10-15
'A-Z  15-42
'[]();!&
Zeichenwandlung:
   Select Case Byte2

      Case 48 To 57                                            '0-9
         Byte2 = Byte2 - 48
      Case 65 To 90                                            'A-Z
         Byte2 = Byte2 - 49
      Case 97 To 122                                           'a-z
         Byte2 = Byte2 - 81
      Case 45                                                  '-
         Byte2 = 10
      Case 58                                                  ':
         Byte2 = 11
      Case 42                                                  '"*"
         Byte2 = 107
      Case 43                                                  '"+"
         Byte2 = 106
      Case 47                                                  '/
         Byte2 = 12
      Case 46                                                  '.
         Byte2 = 13
      Case 44                                                  ',
         Byte2 = 14
      Case 39                                                  ' '
         Byte2 = 15
      Case 91                                                  '[
         Byte2 = 42
      Case 93                                                  ']
         Byte2 = 43
      Case 40                                                  ' (
         Byte2 = 44
      Case 41                                                  ' )
         Byte2 = 45
      Case 59                                                  ';
         Byte2 = 46
      Case 33                                                  '!
         Byte2 = 47
      Case 38                                                  '&
         Byte2 = 48
'   Case 32                                                  ' Leerzeichen
'        Byte2 = 127
      Case 42                                                  '"*"
         Byte2 = 56
      Case 63                                                  '?
         Byte2 = 122
      Case Else
         Byte2 = 127
   End Select
Return

'****************************************************************
'       EEProm auslesen                                         *
'****************************************************************
Eeprom_lesen:
   For I = 0 To 7
      N = 2 * I
      N = N + 1
      Readeeprom Comd , N
      Comx(i + 1) = Comd
      debug comd
   Next
   Readeeprom Zeigtitel , 0
   Readeeprom col , 200
   Readeeprom lin , 201
   Readeeprom Logo, 210
Return
'****************************************************************
'       CW-Zeichen ausgeben                                     *
'****************************************************************
CW_Logo:
   For Osd_n = 1 To Len(Logo)
      T = Mid(Logo ,Osd_n  , 1)
      gosub CW_Zeichen
   Next
return
CW_Zeichen:
   Select Case T

      Case "A"               'da hier nicht bentigt, wurde es zum Sparen des Speichers weg gelassen
         Gosub _k
         Gosub _l
         gosub pau

      Case "B"
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub Pau
      Case "C"
         Gosub _l
         Gosub _k
         Gosub _l
         Gosub _k
         Gosub Pau
      Case "D"
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub Pau
      Case "E"
         Gosub _k
         Gosub Pau
      Case "F"
         Gosub _k                                                 'wegen zu wenig Speicherplatz weg rationalisiert
         Gosub _k
         Gosub _l
         Gosub _k
         Gosub Pau
      Case "G"
         Gosub _l
         Gosub _l
         Gosub _k
         Gosub Pau
      Case "H"
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _k
         gosub pau
      Case "I"
         Gosub _k
         Gosub _k
         Gosub Pau
      Case "J"
         Gosub _k
         Gosub _l
         Gosub _l
         Gosub _l
         Gosub Pau
      Case "K":
         Gosub _l
         Gosub _k
         Gosub _l
         Gosub Pau
      Case "L"
         Gosub _k
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub Pau
      Case "M"
         Gosub _l
         Gosub _l
         gosub pau
      Case "N"
         Gosub _l
         Gosub _k
         Gosub Pau
      Case "O"
         Gosub _l
         Gosub _l
         Gosub _l
         gosub pau
      Case "P"
         Gosub _k
         Gosub _l
         Gosub _l
         Gosub _k
         Gosub Pau
      Case "Q"
         Gosub _l
         Gosub _l
         Gosub _k
         Gosub _l
         Gosub Pau
      Case "R"
         Gosub _k
         Gosub _l
         Gosub _k
         Gosub Pau
      Case "S"
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub Pau
      Case "T"
         Gosub _l
         Gosub Pau
      Case "U"
         Gosub _k
         Gosub _k
         Gosub _l
         Gosub Pau
      Case "V"
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _l
         Gosub Pau
      Case "W"
         Gosub _k
         Gosub _l
         Gosub _l
         Gosub Pau
      Case "X"
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub _l
         Gosub Pau
      Case "Y"
         Gosub _l
         Gosub _k
         Gosub _l
         Gosub _l
         gosub pau
      Case "Z"
         Gosub _l
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub Pau
      Case "0"
         Gosub _l
         Gosub _l
         Gosub _l
         Gosub _l
         Gosub _l
         Gosub Pau

      Case "1"

         Gosub _k
         Gosub _l
         Gosub _l
         Gosub _l
         Gosub _l
         Gosub Pau

      Case "2"

         Gosub _k
         Gosub _k
         Gosub _l
         Gosub _l
         Gosub _l
         Gosub Pau

      Case "3"

         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _l
         Gosub _l
         Gosub Pau

      Case "4"

         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _l
         Gosub Pau

      Case "5"

         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub Pau


      Case "6"

         Gosub _l
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub Pau

      Case "7"

         Gosub _l
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub Pau

      Case "8"

         Gosub _l
         Gosub _l
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub Pau

      Case "9"

         Gosub _l
         Gosub _l
         Gosub _l
         Gosub _l
         Gosub _k
         Gosub Pau
      case "-"
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub _k
         Gosub _l
         Gosub Pau
      case "/"
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub _l
         Gosub _k
         Gosub Pau
      case "?"
         Gosub _k
         Gosub _k
         Gosub _l
         Gosub _l
         Gosub _k
         Gosub _k
         Gosub Pau
      case else
         waitms lang
         waitms lang
         waitms lang
   End Select

Return
'****************************************************************
'       Zeichen ausgeben                                        *
'****************************************************************
_k:                                                         'Punkt
   Sound CW_Out, kurz, 700
   Waitms kurz
Return

_l:                                                         'Strich
   Sound CW_Out,lang,700
   Waitms kurz
Return

Pau:                                                        'kurze Pause zwischen den Zeichen
   Waitms lang
Return
'****************************************************************
'* Interrupt Services                                           *
'****************************************************************
Min_Off:                                                    ' Timer2 Auswertung
   Decr Min_timer
   If Min_timer = 0 Then
      Min_rum = 1
      Min_timer = Min_timeout
   End If
Return

'****************************************************************
'   EEPromwerte beim Brennen speichern                          *
'****************************************************************
Eepromdaten:
   $eeprom
'      Byte 2       Byte1  !!!====!!!  wenn Word gelesen werden dann in umgekehrter Reihenfolge !!!!
   Data 0                                                      ' zeige Startbildschirm
   Data &B0000_0000 , &B1001_0001                              ' COM 1 Zeichen bergeben mit Atribut (att) schreiben
   Data &B0101_0111 , &B1010_0000                              ' COM 2 Vertikal  Start und Gre der Zeihen,Zeichentakt FS=0 2fsc FS=1 4fsc
   Data &B0001_1101 , &B1011_0000                              ' COM 3 Horizontal Start und Greder Zeichen, Punkt-Takt LC=0 LC-Osz. LC=1 Xtal-Osz.
   Data &B0110_0001 , &B1100_0000                              ' COM 4 Display Einstellungen (siehe Dim)
   Data &B0000_0010 , &B1101_1000                              ' COM 5 Display Einstellungen (siehe Dim)     Pal,  HG Blau
   Data &B0001_0001 , &B1110_0100                              ' COM 6 Sync Detektion
   Data &B0000_0001 , &B1111_0000                              ' COM 7 Sync Detektion
   Data &B0000_0000 , &B1000_0000                              ' COM 0 Position  eingeben
'Standard wird nicht verndert
   Data &B0000_0000 , &B1001_0001                              ' COM 1 Zeichen bergeben mit Atribut (att) schreiben
   Data &B0100_1111 , &B1010_0000                              ' COM 2 Vertikal  Start und Gre der Zeihen,Zeichentakt FS=0 2fsc FS=1 4fsc
   Data &B0001_0101 , &B1011_0000                              ' COM 3 Horizontal Start und Greder Zeichen, Punkt-Takt LC=0 LC-Osz. LC=1 Xtal-Osz.
   Data &B0110_0001 , &B1100_0000                              ' COM 4 Display Einstellungen (siehe Dim)
   Data &B0000_0010 , &B1101_1000                              ' COM 5 Display Einstellungen (siehe Dim)     Pal,  HG Blau
   Data &B0001_0001 , &B1110_0100                              ' COM 6 Sync Detektion
   Data &B0000_0001 , &B1111_0000                              ' COM 7 Sync Detektion
   Data &B0000_0000 , &B1000_0000                              ' COM 0 Position  eingeben
'Ab 33 Knnen 190 bytes ins EEProm geschrieben werden.
   Data "OSD V1J VON DL1MFK JAN/16~"                         '
   $data